import { Agile } from './internal';
export interface IntegrationConfig<F = any> {
    name?: any;
    frameworkInstance?: F;
    bind?: (agileInstance: Agile) => void;
    updateMethod?: (componentInstance: any, updatedData: Object) => void;
}
export declare class Integration<F = any> {
    ready?: boolean;
    config: IntegrationConfig<F>;
    constructor(config: IntegrationConfig);
}
export declare class Integrations {
    agileInstance: () => Agile;
    loadedIntegrations: Set<Integration>;
    constructor(agileInstance: Agile);
    /**
     * Integrates a framework into Agile
     */
    integrate(integration: Integration): void;
    /**
     * Binds the Framework to Agile
     */
    bind(): void;
    /**
     * Updates Framework States
     */
    update(componentInstance: any, updatedData: Object): void;
    /**
     * Checks weather integrations are registered
     */
    hasIntegration(): boolean;
}
