import { Agile, State } from '../../internal';
import { ComponentSubscriptionContainer } from "./ComponentSubscriptionContainer";
import { CallbackSubscriptionContainer } from "./CallbackSubscriptionContainer";
export declare type SubscriptionContainer = ComponentSubscriptionContainer | CallbackSubscriptionContainer;
export declare class SubController {
    agileInstance: () => Agile;
    components: Set<ComponentSubscriptionContainer>;
    callbacks: Set<CallbackSubscriptionContainer>;
    constructor(agileInstance: Agile);
    /**
     * Subscribe to Agile State with a returned object of props this props can than be returned by the component (See react-integration)
     */
    subscribeWithSubsObject(subscriptionInstance: any, subs?: {
        [key: string]: State;
    }): {
        subscriptionContainer: SubscriptionContainer;
        props: {
            [key: string]: State['value'];
        };
    };
    /**
     * Subscribe to Agile State
     */
    subscribeWithSubsArray(subscriptionInstance: any, subs?: Array<State>): SubscriptionContainer;
    /**
     * Unsubscribe a component or callback
     */
    unsubscribe(subscriptionInstance: any): void;
    /**
     * Registers the Component/Callback Subscription and returns a SubscriptionContainer
     */
    registerSubscription(integrationInstance: any, subs?: Array<State>): SubscriptionContainer;
    /**
     * This will mount the component (Mounts currently only useful in Component based Subscription)
     */
    mount(integrationInstance: any): void;
    /**
     * Registers Component Subscription
     * Note: Helper Function
     */
    private registerComponentSubscription;
    /**
     * Registers Callback Subscription
     * Note: Helper Function
     */
    private registerCallbackSubscription;
}
